// Visual Interface.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "Visual Interface.h"

#define MAX_LOADSTRING 100

#define X_POS 50
#define Y_POS 50
#define WIDTH 400
#define HEIGHT 600

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
HWND hWnd;
HWND hTraningBox;
HWND hPropertiesBox;

int traningFlag = 1;
int propertiesFlag = 1;
int offset = 0;
// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
int					InitTraningMenu(int X, int Y);
int					InitPropertiesMenu(int X,int Y);
BOOL				InitHotKeys();
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	GrpBoxWndProc(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_VISUALINTERFACE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_VISUALINTERFACE));

	InitHotKeys();

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_VISUALINTERFACE));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+0);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_VISUALINTERFACE);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));
	
	WNDCLASS ww;

	GetClassInfo(hInst,"BUTTON",&ww);
	ww.lpszClassName = "grpBox";
	ww.lpfnWndProc = GrpBoxWndProc;
	RegisterClass(&ww);

	//hTraningBox = CreateWindow("grpBox","Trning",WS_CHILD |WS_VISIBLE | WS_BORDER | BS_GROUPBOX,10,10,300,100,hWnd,(HMENU) 100, hInst,NULL);
	

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      X_POS, Y_POS, WIDTH, HEIGHT, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   HWND hGroupBox = CreateWindow("BUTTON", "Capture", WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
             10,            // X Position 
             10,            // Y Position 
             WIDTH-35,           // X Width 
             HEIGHT-75,           // Y Height 
             hWnd, (HMENU) -1, hInst, NULL);  

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	UINT uVirtKey;

	switch (message)
	{
	case WM_HOTKEY:
		uVirtKey = (UINT) HIWORD(lParam);	//   

		if(uVirtKey == 0x54)//T
		{
			if(propertiesFlag)
			{
				if(traningFlag)
				{
					int wTranin = InitTraningMenu(WIDTH,10);

					MoveWindow(hWnd,X_POS,Y_POS,WIDTH+wTranin+30,HEIGHT,1);
					RegisterHotKey(hTraningBox,2,NULL,0x45); //E
					RegisterHotKey(hTraningBox,5,NULL,0x53); //S

					traningFlag = 0;
				}
				else
				{
					DestroyWindow(hTraningBox);
					MoveWindow(hWnd,X_POS,Y_POS,WIDTH,HEIGHT,1);

					UnregisterHotKey(hTraningBox,2);
					UnregisterHotKey(hTraningBox,5);

					traningFlag = 1;
				}
			}
		}
		if(uVirtKey == 0x50)//P
		{
			if(traningFlag)
			{
				if(propertiesFlag)
				{
					int wProp = InitPropertiesMenu(WIDTH,10);
					MoveWindow(hWnd,X_POS,Y_POS,WIDTH+wProp+30,HEIGHT,1);
					propertiesFlag = 0;
				}
				else
				{
					DestroyWindow(hPropertiesBox);
					MoveWindow(hWnd,X_POS,Y_POS,WIDTH,HEIGHT,1);
					propertiesFlag = 1;
				}
			}
		}
		if(uVirtKey == 0x1B)//Esc
		{
			DestroyWindow(hWnd);
		}
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		if(LOWORD(wParam)==118)
		{
			//MessageBox(hWnd, "", "!", MB_YESNO|MB_ICONQUESTION);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

LRESULT CALLBACK GrpBoxWndProc(HWND hTraningBox, UINT message, WPARAM wParam, LPARAM lParam)
{
	UINT uVirtKey;

	switch (message)
	{
	case WM_HOTKEY:
		uVirtKey = (UINT) HIWORD(lParam);	//   

		if(uVirtKey == 0x45)//E
		{
			MessageBox(hWnd, "StopTraning", "Traning", MB_OK|MB_ICONINFORMATION);
		}
		if(uVirtKey == 0x53)//S
		{
			HWND tmpWnd= GetWindow(hTraningBox,GW_CHILD);
			char Caption[30];
			while(tmpWnd)
			{
				GetWindowText(tmpWnd,Caption,30);
				if(Button_GetCheck(tmpWnd)) 
				{
					MessageBox(hWnd, Caption, "Traning", MB_OK|MB_ICONINFORMATION);
				}
				tmpWnd= GetWindow(tmpWnd,GW_HWNDNEXT);
			}
		}
	case WM_COMMAND:
		if(LOWORD(wParam)==118)
		{
			HWND tmpWnd= GetWindow(hTraningBox,GW_CHILD);
			char Caption[30];
			while(tmpWnd)
			{
				GetWindowText(tmpWnd,Caption,30);
				if(Button_GetCheck(tmpWnd)) 
				{
					MessageBox(hWnd, Caption, "Traning", MB_OK|MB_ICONINFORMATION);
				}
				tmpWnd= GetWindow(tmpWnd,GW_HWNDNEXT);
			}
		}
		if(LOWORD(wParam)==119)
		{
			MessageBox(hWnd, "StopTraning", "Traning", MB_OK|MB_ICONINFORMATION);
		}
		
		break;
	default:
		return DefWindowProc(hTraningBox, message, wParam, lParam);
	}
	return 0;
}

int InitTraningMenu(int X, int Y)
{
	//HWND Button[17];
		
	int widthTraningBox = 250; 
	int heightTraningBox = HEIGHT-75;

	hTraningBox = CreateWindow("grpBox","Trning", WS_CHILD |WS_VISIBLE| WS_BORDER, X,Y,widthTraningBox,heightTraningBox,hWnd,(HMENU) 100, hInst,NULL);
	
//  |BS_GROUPBOX
//  |WS_BORDER
//	hTraningBox = CreateWindow("BUTTON", "Traning", WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
//            X,            // X Position 
//             Y,            // Y Position 
//             widthTraningBox,           // X Width 
//            heightTraningBox,           // Y Height 
//             hWnd, (HMENU) 100, hInst, NULL);

	

	int distFromBorderY = 40;
	int distFromBorderX = 50;

	char text_buf[15]="";
	int radioBtnWidth = 30;
	int radioBtnHeight = 15;
	int distance = 20;

	CreateWindow("Static", "Traning", WS_VISIBLE|WS_CHILD,100,10,50,20,hTraningBox,NULL,hInst,NULL);

	int y = 0;

	for(int i=0; i<10; i++)
	{
		itoa(i,text_buf,10);
		y = (i*distance)+distFromBorderY;
		CreateWindow("button", text_buf, WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON, distFromBorderX, y, radioBtnWidth, radioBtnHeight, hTraningBox, (HMENU)101+i, hInst, NULL);
	}

	CreateWindow("button", "+", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,distFromBorderX ,y+20, radioBtnWidth, radioBtnHeight, hTraningBox, (HMENU)110, hInst, NULL);
	CreateWindow("button", "-", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,distFromBorderX ,y+40, radioBtnWidth, radioBtnHeight, hTraningBox, (HMENU)111, hInst, NULL);
	CreateWindow("button", "=", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,distFromBorderX ,y+60, radioBtnWidth, radioBtnHeight, hTraningBox, (HMENU)112, hInst, NULL);

	CreateWindow("button", "(", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,distFromBorderX ,y+90, radioBtnWidth, radioBtnHeight, hTraningBox, (HMENU)113, hInst, NULL);
	CreateWindow("button", ")", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,distFromBorderX ,y+120, radioBtnWidth, radioBtnHeight, hTraningBox, (HMENU)114, hInst, NULL);
	CreateWindow("button", "*", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,distFromBorderX ,y+150, radioBtnWidth, radioBtnHeight, hTraningBox, (HMENU)115, hInst, NULL);
	CreateWindow("button", "/", WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,distFromBorderX ,y+180, radioBtnWidth, radioBtnHeight, hTraningBox, (HMENU)116, hInst, NULL);

	int xListBox = distFromBorderX+radioBtnWidth+60;
	int yListBox = distFromBorderY;
	CreateWindow("ListBox", NULL, WS_CHILD | WS_VISIBLE | LBS_STANDARD | LBS_WANTKEYBOARDINPUT | WS_BORDER, xListBox, yListBox, 90, 400, hTraningBox, (HMENU)117, hInst, NULL);
	
	int xHKey = 150;
	int widthHKey = 90;
	int heightHKey = 20;
	CreateWindow("Static", "Hot Key S", WS_VISIBLE|WS_CHILD, xHKey, y+225,widthHKey,heightHKey,hTraningBox,NULL,hInst,NULL);
	CreateWindow("Static", "Hot Key E", WS_VISIBLE|WS_CHILD, xHKey, y+265,widthHKey,heightHKey,hTraningBox,NULL,hInst,NULL);

	int xBtn=10;
	int widthBtn = 100;
	int heightBtn = 30;

	CreateWindow("button", "Start Traning", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, xBtn, y+220, widthBtn, heightBtn, hTraningBox, (HMENU)118, hInst, NULL);
	CreateWindow("button", "Stop Traning", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, xBtn, y+260, widthBtn, heightBtn, hTraningBox, (HMENU)119, hInst, NULL);

	return widthTraningBox;
}
int InitPropertiesMenu(int X,int Y)
{
	int widthPropertiesBox = 130;
	int heightPropertiesBox = 120;

	hPropertiesBox = CreateWindow("grpBox","Trning", WS_CHILD |WS_VISIBLE| WS_BORDER, 
		X,Y,
		widthPropertiesBox,heightPropertiesBox,
		hWnd, (HMENU) 200, hInst,NULL);
	
	CreateWindow("Static", "Properties", WS_VISIBLE|WS_CHILD, 30 , 5, 100, 20, hPropertiesBox, NULL, hInst, NULL);
	

//	hPropertiesBox = CreateWindow("BUTTON", "Properties", WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
//             X,            // X Position 
//             Y,            // Y Position 
//             widthPropertiesBox,           // X Width 
//             heightPropertiesBox,           // Y Height 
//             hWnd, (HMENU) 200, hInst, NULL);

	int textXpos = 10;
	int textYpos = 30;
	int textW = 50;
	int textH = 20;
	int distance = 10;

	CreateWindow("Static", "S max", WS_VISIBLE|WS_CHILD, textXpos , textYpos, textW, textH, hPropertiesBox, NULL, hInst, NULL);
	CreateWindow("Static", "V min ", WS_VISIBLE|WS_CHILD, textXpos, textYpos+textH+distance, textW, textH, hPropertiesBox, NULL, hInst, NULL);
	CreateWindow("Static", "V max ", WS_VISIBLE|WS_CHILD, textXpos, textYpos+textH*2+distance*2, textW, textH, hPropertiesBox, NULL, hInst, NULL);

	int xPosUpDown = textXpos + textW + 10;
	int yPosUpDown = textYpos;
	int w = 30;
	int h = 20;

//	SendMessage(Label1, WM_SETFONT, hFont, 0); // 

	HWND hStcTextS = CreateWindow("Static", "0", WS_VISIBLE|WS_CHILD|WS_BORDER, xPosUpDown , yPosUpDown, w, h, hPropertiesBox, NULL, hInst, NULL);
	HWND hUpDownS = CreateUpDownControl(UDS_SETBUDDYINT |UDS_AUTOBUDDY |WS_CHILD | WS_BORDER | WS_VISIBLE,xPosUpDown + w,yPosUpDown, 10,h, hPropertiesBox,201,hInst, hStcTextS, 100, 0,0);
 
	HWND hStcTextVmin = CreateWindow("Static", "0", WS_VISIBLE|WS_CHILD|WS_BORDER, xPosUpDown , yPosUpDown+h+distance, w, h, hPropertiesBox, NULL, hInst, NULL);
	HWND hUpDownVmin = CreateUpDownControl(UDS_SETBUDDYINT |UDS_AUTOBUDDY |WS_CHILD | WS_BORDER | WS_VISIBLE,xPosUpDown + w,yPosUpDown+h+distance,10,h,hPropertiesBox,202,hInst, hStcTextVmin, 100, 0,0);
 
	HWND hStcTextVmax = CreateWindow("Static", "0", WS_VISIBLE|WS_CHILD|WS_BORDER, xPosUpDown , yPosUpDown+h*2+distance*2, w, h, hPropertiesBox, NULL, hInst, NULL);
	HWND hUpDownVmax = CreateUpDownControl(UDS_SETBUDDYINT |UDS_AUTOBUDDY |WS_CHILD | WS_BORDER | WS_VISIBLE,xPosUpDown + w,yPosUpDown+h*2+distance*2,10,h,hPropertiesBox,203,hInst, hStcTextVmax, 100, 0,0);
 
	return widthPropertiesBox;
}
BOOL InitHotKeys()
{
	RegisterHotKey(hWnd,0,NULL,0x1B); //Esc
	RegisterHotKey(hWnd,1,NULL,0x43); //C
//	RegisterHotKey(hWnd,2,NULL,0x45); //E
	RegisterHotKey(hWnd,3,NULL,0x50); //P
	RegisterHotKey(hWnd,4,NULL,0x52); //R
//	RegisterHotKey(hWnd,5,NULL,0x53); //S
	RegisterHotKey(hWnd,6,NULL,0x54); //T

	return 1;
}
